<?php
/*-----------------------------------------------------------------------------
* IMPORT μTorrent/BitTorrent Torrents to Deluge v0.2 (Windows Only)           *
*                                                                             *
* Author: Vaggelis Koutroumpas vaggelis@koutroumpas.gr (c)2009-2014    		  *
*                                                                             *
*                                                                             *
* This program is free software: you can redistribute it and/or modify        *
* it under the terms of the GNU General Public License as published by        * 
* the Free Software Foundation, either version 3 of the License, or           *
* (at your option) any later version.                                         *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program. If not, see <http://www.gnu.org/licenses/>.        *
*                                                                             *
*-----------------------------------------------------------------------------*/

@set_time_limit(0);
@error_reporting(0);
@ini_set('display_errors', 0);

require('./settings.php');
require('./BDecode.php');

if ( is_file($DELUGE) == FALSE)
{
	die("Deluge not found! Dying :(");
}

$clihandle = fopen ("php://stdin","r");

echo "\n================================================================\n";
echo "| STARTING IMPORT!                                             |\n";
echo "================================================================\n\n\n";

//Open resume.dat and decode it to parse its torrents.
$content = file_get_contents( $BITTORRENT_PATH . '/resume.dat');
$content = BDecode($content);

//Loop over all uTorrent torrents
foreach($content as $key => $value){
	$SAVE_PATH = FALSE;
	$SAVE_PATH_expl = FALSE;
	$TORRENT_PATH = FALSE;
	
	//Do not process .fileguard
	if ($key != '.fileguard'){

		//Check if Save Path is set on resume.dat
		if ($content[$key]['path']){
		
			// Prepare vars
			$TORRENT_PATH = $BITTORRENT_PATH . "\\" . $key;
			$SAVE_PATH = $content[$key]['path'];
			// $SAVE_PATH contains a full filename path, get the base path from it
			$SAVE_PATH = realpath( dirname($SAVE_PATH) );
			// Substitute \\ with / to make Deluge happy
			$SAVE_PATH = str_replace('\\','/',$SAVE_PATH);			
		
			//Print current torrent being processed
			echo "Torrent File: " .  $TORRENT_PATH . "\n";
			echo "Save path: " . $SAVE_PATH . "\n";
			
			//Check if .torrent file and save path exist before adding the torrent to Deluge
			if ( is_file("wfio://".$TORRENT_PATH) ) {
			
				if ( file_exists ($SAVE_PATH) ){
					$torrent_dst_file = "a.torrent";
					$copycmd = "copy /Y \"".$TORRENT_PATH."\" ".$torrent_dst_file;
					//echo "Copy command: \"".$copycmd."\" \n";
					system($copycmd);
										
					//$commandstr='"'.$DELUGE.'"' . ' add -p \''.$SAVE_PATH.'\' \''.$TORRENT_PATH.'\'';
					$commandstr='"'.$DELUGE.'"' . ' add -p \''.$SAVE_PATH.'\' \''.$torrent_dst_file.'\'';
					
					//Just print the deluge command if DRYRUN is enabled	                
					echo "Command: ".$commandstr."\n";
					if ($DRYRUN == FALSE){
						$result=0;
						// Add to Deluge
						passthru ($commandstr, $result);	
						//echo "Result: ".$result."\n";
						if($result != 0)
						{
							echo "Deluge returned an error. Check for it and then press a key to continue...\n";
							$line = fgets($clihandle);
						}						
            			sleep ($TIME_TO_WAIT);
						echo "\n\n\n";
					}
			
				}else{
					echo "[ERROR] Save path does not exist\n\n\n";
				}

			}else{
				echo "[ERROR] .torrent file missing\n\n\n";
			}
		}
	} 
}

echo "\n\n\n================================================================\n";
echo "| IMPORT COMPLETE!                                             |\n";
echo "================================================================\n";

?>